comment #

   XMS.ASM
  ---------

  Handles XMS memory.

  Copyright (C) 2000 by Josef Drexler <jdrexler@julian.uwo.ca>

  Distributed under the terms of the GNU General Public License.  For more
  information please read the file COPYING which is included in the
  distribution.

#

locals @@

.model small,C

.data

xmsfunc dd ?

xmsret dw ?
xmserror db ?

.code

.386

public xmsinit,xmsmemfree,xmsalloc,xmsaccess,xmsfree,xmsret,xmserror

callxmsfunc macro command
	mov ah,command
	call xmsfunc
	mov xmsret,ax
	mov xmserror,bl
endm

;int xmsinit(); -> 0=no XMS, 1=XMS init successful
xmsinit proc

	; XMS installed?
	mov ax,4300h
	int 2fh
	cmp al,80h
	mov ax,0
	jne short @@noxmsdriver

	; Get XMS function address
	mov ax,4310h
	int 2fh
	mov word ptr [xmsfunc],bx
	mov word ptr [xmsfunc+2],es
	mov ax,1

@@noxmsdriver:
	ret
xmsinit endp

;int xmsmemfree(); returns largest available block in KB
xmsmemfree proc
	callxmsfunc 8
	ret
xmsmemfree endp

;int xmsalloc(int size); returns handle or 0 if no memory was allocated
xmsalloc proc
	arg blocksize:word=arglen

	mov dx,blocksize
	callxmsfunc 9
	mov ax,dx	; return the handle not the exit status
	ret
xmsalloc endp

;int xmsaccess(int handle, void far *buffer, U32 ofs, U32 length, int action);
;returns 1 if success, 0 if not
xmsaccess proc
	arg handle:word,buffer:dword,ofs:dword,len:dword,action:word=arglen
	local movestruct:word:8=locallen

	push ecx
	push edi
	push si

	mov eax,len
	mov bx,0
	mov ecx,buffer
	mov dx,handle
	mov edi,ofs

	cmp action,0	; 0=read
	jne short @@itsaread
	xchg bx,dx
	xchg ecx,edi

@@itsaread:
	mov dword ptr movestruct[0],eax
	mov movestruct[4],bx
	mov dword ptr movestruct[6],ecx
	mov movestruct[10],dx
	mov dword ptr movestruct[12],edi

	lea si,offset movestruct	; ds=ss for small model
	callxmsfunc 0bh

	pop si
	pop ecx
	pop edi
	ret
xmsaccess endp

;int xmsfree(int handle);
;return 1 if success, 0 if not
xmsfree proc
	arg handle:word

	mov dx,handle
	callxmsfunc 0ah
	ret
xmsfree endp

end
